convert <- function(var, x)
{ 
 if (var == 'precip2') x = exp(x) * 30 * 86400
 if (var == 'logml') x = exp(x) 
 return (x)
}


colors=c(Orog_data='black', No_Orog_data='red')

plot_MAR <- function(var,varname, print_legend=FALSE)
{

ymin = min(convert ( var , c(
       MAR$No_Orog_data[[var]][['simple_integrals']]['y',] 
     - sqrt ( MAR$No_Orog_data[[var]][['double_integrals']]['Sp',] )  , 
       MAR$Orog_data[[var]][['simple_integrals']]['y',] 
     - sqrt ( MAR$Orog_data[[var]][['double_integrals']]['Sp',] ) )  ))

ymax = max(convert ( var, c(
       MAR$No_Orog_data[[var]][['simple_integrals']]['y',] 
     + sqrt (  MAR$No_Orog_data[[var]][['double_integrals']]['Sp',] )  , 
       MAR$Orog_data[[var]][['simple_integrals']]['y',] 
     + sqrt ( MAR$Orog_data[[var]][['double_integrals']]['Sp',] ) )))

  plot(c(levels,levels) , 
       c( convert( var, MAR$No_Orog_data[[var]]$simple_integrals['y',] ), 
          convert( var, MAR$Orog_data[[var]]$simple_integrals['y',] ) ) , 
                    , type='n', col='blue', xlab="Glaciation Level", main=varname, ylab="" , axes=FALSE, 
                    frame=TRUE, ylim=c(ymin,ymax))
  axis(1, at=seq(11))
  axis(2)
  for  ( exp in c("Orog_data","No_Orog_data")  ) {
    lines (levels, convert ( var, MAR[[exp]][[var]][['simple_integrals']]['y',]), type='l', col=colors[exp]) 
    lines (levels, convert ( var, MAR[[exp]][[var]][['simple_integrals']]['y',] 
      + sqrt  ( MAR[[exp]][[var]][['double_integrals']]['Sp',] )),  type='l', lty=2, col=colors[exp]) 
    lines (levels, convert ( var,  MAR[[exp]][[var]][['simple_integrals']]['y',] 
      - sqrt  ( MAR[[exp]][[var]][['double_integrals']]['Sp',] ) ),  type='l', lty=2, col=colors[exp]) 
  }
  if (print_legend) legend('topright', c('Orog','No Orog'), lty=1, col=colors)
}


levels=seq(1,11,l=10)

pdf('../Pdf/response_to_ice.pdf', height=9, width=9, pointsize=12)
par(las=1)
par(mfrow=c(2,2))

load('../Data/RData/MAR_4.rda')

plot_MAR('temp2',expression(paste('Continental temperature (',degree,'C)')))
plot_MAR('precip2', 'Continental precipitation (mm/month)')
plot_MAR('sst', expression(paste('Sea-surface temperature (',degree,'C)')))
plot_MAR('logml', 'Mixed-layer depth (m)', print_legend=TRUE)
dev.off()
