# The MIT License (MIT)
# Supplementary Material to Article : 
# P. A. Araya Melo, M. Crucifix, N. Bounceur, 
# Global sensitivity analysis of Indian Monsoon during the Pleistocene
# http://www.clim-past-discuss.net/10/1609/2014/cpd-10-1609-2014.html
# 
# Copyright (c) 2014 Michel Crucifix
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
# 


 # load input data

 RDatapath = file.path('..','Data','RData')
 load(file.path(RDatapath,'exp_output.rda'))
 load(file.path(RDatapath,'lambda.rda'))

 ### this is a bug in GP . Need to set this
 verbose = TRUE
 require(GP)

 ### need to adatp ice levels between orog and no_orog for comparison
 
 to_raise = which(DATA$No_Orog$X[,5] > 0)
 DATA$No_Orog$X[to_raise,5] = DATA$No_Orog$X[to_raise,5] +.1

 # calibrate a list of emulators 
 # using the optimized lambdas

 exps = c ( Orog_without_11_40='Orog_without_11_40', No_Orog= "No_Orog")
 vars = names(Lambdas$Orog_full)
 names ( vars )  = vars

# ATTENTION : We use the same hyperparameters for both experiments 
 Lambdas$No_Orog = Lambdas$Orog_without_11_40

 E <- lapply(exps, function(exp) 
      lapply(vars, function(var) GP_C ( DATA[[exp]]$X, DATA[[exp]]$Y[,var], Lambdas[[exp]][[var]] ) ) )

  source('./rhoarray.R')
 names(vars) <- vars

 MAR = lapply( exps , function(exp) 
 {
   X = DATA[[exp]]$X
   rho <- rhocalc(attr(X,"scales"), attr(X,"shifts"), n=c(ecosw=6, esinw=6, eps=6, co2=6, ice=10))
   lapply( vars, function(v) marginals (E[[exp]][[v]], rho, c(5)))
 }
 )

# rename experiments for compatibility with plotting routi

names(MAR) = c('Orog_data','No_Orog_data')
save(file=file.path(RDatapath, ' MAR_4.rda'), MAR ) 
# source('plot_mar.R') 
